version: "3.9"

services:
  demo-wallet:
    container_name: demo-wallet
    build:
      context: .
      dockerfile: DockerFile
    environment:
      PG_DSN: "host=postgres port=5432 dbname=demo_wallet user=postgres password=postgres sslmode=disable"
#      PG_DSN: "host=pgboucer port=5432 dbname=demo_wallet user=postgres password=postgres sslmode=disable"
    ports:
      - "8002:8002" # gRPC
      - "8001:8001" # REST
      - "9100:9100" # Metrics prometheus
      - "8000:8000" # Status prometheus
    healthcheck:
      test: [ 'CMD', 'curl', '-v', 'http://localhost:8000/live' ]
      interval: 10s
      timeout: 10s
      retries: 2
      start_period: 20s
    networks:
      - ompnw
    depends_on:
      - postgres
      - pgboucer

  nginx:
    container_name: nginx
    image: nginx:latest
    restart: unless-stopped
    logging:
      driver: 'gelf'
      options:
        gelf-address: 'udp://localhost:12201'
        tag: nginx
    ports:
      - "8080:8080"
    volumes:
      - ./docker/nginx/conf.d:/etc/nginx/conf.d
    networks:
      - ompnw
    depends_on:
      - demo-wallet
      - swagger-ui

  swagger-ui:
    container_name: swagger-ui
    image: swaggerapi/swagger-ui:v4.10.3
    restart: always
    volumes:
      - ./pkg/swagger:/swagger
    environment:
      SWAGGER_JSON: /swagger/demo-wallet/demo-wallet.swagger.json
    networks:
      - ompnw
    depends_on:
      - demo-wallet

networks:
  ompnw:
    driver: bridge
